package privileged

import (
	"net"
	"reflect"
	"testing"

	omd "git.loafle.net/overflow/model/discovery"
	"git.loafle.net/overflow_scanner/probe/__test"
	"git.loafle.net/overflow_scanner/probe/discovery/session"
	"git.loafle.net/overflow_scanner/probe/discovery/types"
	"git.loafle.net/overflow_scanner/probe/internal/pcap"
	"github.com/google/gopacket"
)

func Test_scanV4(t *testing.T) {
	s := session.NewMockDiscoverySession(
		"testRequester",
		types.DiscoveryRequestTypeHost,
		__test.Zone(),
		__test.DiscoverHost(
			__test.DiscoveryConfig(),
			1,
			254,
			nil,
		),
	)

	type args struct {
		discoverySession session.DiscoverySession
	}
	tests := []struct {
		name    string
		args    args
		wantErr bool
	}{
		{
			name: "1",
			args: args{
				discoverySession: s,
			},
			wantErr: false,
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if err := scanV4(tt.args.discoverySession); (err != nil) != tt.wantErr {
				t.Errorf("scanV4() error = %v, wantErr %v", err, tt.wantErr)
			}
		})
	}
}

func Test_sendICMP4(t *testing.T) {
	type args struct {
		ps               pcap.PCapScanner
		discoverySession session.DiscoverySession
		stopChan         chan struct{}
	}
	tests := []struct {
		name    string
		args    args
		wantErr bool
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if err := sendICMP4(tt.args.ps, tt.args.discoverySession, tt.args.stopChan); (err != nil) != tt.wantErr {
				t.Errorf("sendICMP4() error = %v, wantErr %v", err, tt.wantErr)
			}
		})
	}
}

func Test_handlePacketICMP4(t *testing.T) {
	type args struct {
		zone        *omd.Zone
		targetHosts []net.IP
		hosts       map[string]*omd.Host
		packet      gopacket.Packet
	}
	tests := []struct {
		name string
		args args
		want *omd.Host
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if got := handlePacketICMP4(tt.args.zone, tt.args.targetHosts, tt.args.hosts, tt.args.packet); !reflect.DeepEqual(got, tt.want) {
				t.Errorf("handlePacketICMP4() = %v, want %v", got, tt.want)
			}
		})
	}
}

func Test_makePacketICMPv4(t *testing.T) {
	type args struct {
		zone *omd.Zone
	}
	tests := []struct {
		name    string
		args    args
		want    *PacketICMPv4
		wantErr bool
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			got, err := makePacketICMPv4(tt.args.zone)
			if (err != nil) != tt.wantErr {
				t.Errorf("makePacketICMPv4() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if !reflect.DeepEqual(got, tt.want) {
				t.Errorf("makePacketICMPv4() = %v, want %v", got, tt.want)
			}
		})
	}
}
